#include <bits/stdc++.h>
using namespace std;

typedef unsigned long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
        freopen("tba.INP", "r", stdin);
    	freopen("Tba.OUT", "w", stdout);
    int n; cin >> n;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];

    vector<vector<ll>> dp(n + 1, vector<ll>(n + 1, 1e18));
    vector<vector<int>> opt(n + 1, vector<int>(n + 1));

    for (int i = 1; i <= n; i++) dp[i][i] = 0;
    for (int i = 1; i < n; i++) dp[i][i + 1] = 0;
    for (int i = 1, j = 3; j <= n; i++, j++) {
        dp[i][j] = (a[j] - a[i]) * (a[j] - a[i]);
        opt[i][j] = i + 1;
    }

    for (int len = 4; len <= n; len++)
        for (int i = 1, j = len; j <= n; i++, j++)
            for (int k = opt[i][j - 1]; k <= opt[i + 1][j]; k++)
                if (dp[i][j] > dp[i][k] + dp[k][j] + (a[j] - a[i]) * (a[j] - a[i])) {
                    dp[i][j] = dp[i][k] + dp[k][j] + (a[j] - a[i]) * (a[j] - a[i]);
                    opt[i][j] = k;
                }

    cout << dp[1][n] << "\n";
    return 0;
}
